local HealingTracker = _G.HealingTracker
local ReportFrame = HealingTracker.ReportFrame
local pdb = nil
local AceGUI = LibStub("AceGUI-3.0")
local lastwindow = nil

function ReportFrame:Init()
	pdb = HealingTracker.ProfileOptions
end

-- show frame
function ReportFrame:Show()
	
	local window = AceGUI:Create("Window")
	lastwindow = window
	window:SetWidth(380)
	window:SetHeight(160)
	window:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	window:SetLayout("Flow")
	window:SetTitle("Report Logs")
	window:EnableResize(false)
		
	local chs = AceGUI:Create("Dropdown")
	chs:SetLabel("Channel")
	chs:SetWidth(150)
	chs:SetList({})
	local channels = { "Raid", "Party", "Guild", "Say", "Whisper" }
	table.foreach(channels, function(k,v) chs:AddItem(k,v) end)
	chs:SetValue(1)
	chs:SetCallback("OnValueChanged", function(f, e, value)
			if value == 5 then
				window.whisper:Show()
				window.whisper:SetText("")
			else
				window.whisper:Hide()
			end
		end)
	window:AddChild(chs)
		
	local recCount = AceGUI:Create("Slider")
	recCount:SetLabel("Records")
	recCount:SetSliderValues(1, 20, 1)
	recCount:SetWidth(150)
	recCount:SetValue(5)
	window:AddChild(recCount)
		
	local repWhisper = AceGUI:Create("EditBox")
	repWhisper:SetLabel("Player")
	repWhisper:SetWidth(150)
	window:AddChild(repWhisper)
		
	local repButton = AceGUI:Create("Button")
	repButton:SetWidth(100)
	repButton:SetText("Report")
	repButton:SetCallback("OnClick", function(self, event, value)
		local recordCount = window.records:GetValue()
		local targetPlayer = window.whisper:GetText()
		local targetChannel = window.channel:GetValue()
		local chatType = nil
		local chatChannel = nil
		if targetChannel == 1 then
			chatType = "RAID"
		elseif targetChannel == 2 then
			chatType = "PARTY"
		elseif targetChannel == 3 then
			chatType = "GUILD"
		elseif targetChannel == 4 then
			chatType = "SAY"
		elseif targetChannel == 5 then
			chatType = "WHISPER"
			chatChannel = targetPlayer
		end
		if chatType == nil then return end
		
		local selectedSegment = HealingTracker.Segments.Current
		SendChatMessage("Healing Tracker logs for "..selectedSegment.Title, chatType, nil, chatChannel)
		local k = 1
		for i, v in ipairs(selectedSegment.Players) do
			if v ~= nil then
				local totHeal = HealingTracker.Helper:ReadableNumber(v.AidfulHeal + v.AidfulPeriodicHeal)
				local totPoint = v.TotalMultiply + v.TotalRegular
				if totPoint == 0 then break end
				SendChatMessage(k..". "..v.Name.." ..... "..totHeal.." ... "..totPoint.." points", chatType, nil, chatChannel)
				k = k + 1
				if k > recordCount then break end
			end
		end
	end)
	
	window:AddChild(repButton)
	
	window.whisper = repWhisper
	window.button = repButton
	window.channel = chs
	window.records = recCount
	
end

function ReportFrame:Hide()
	if lastwindow ~= nil then
		lastwindow:Hide()
		lastwindow = nil
	end
end

function ReportFrame:Reset()
end

function ReportFrame:Refresh()
end
